import { defineStore } from "pinia";
export const getUrl = (baseUrl, url) => {
  if (url.startsWith("/")) {
    if (baseUrl.endsWith("/")) {
      return new URL(baseUrl.slice(0, -1) + url);
    }
    return new URL(baseUrl + url);
  }
  return new URL(url);
};
export const processIncludedResources = (doc) => {
  if (doc?.included) {
    doc.included.forEach((includedResource) => {
      const useIncludedStore = defineStore(includedResource.type, {});
      const includedStore = useIncludedStore();
      includedStore.data[includedResource.id] = includedResource;
    });
  }
};
export const processIndexData = async (json, store) => {
  const jsonData = json.data;
  const insertData = jsonData.reduce((acc, val) => {
    return { ...acc, [val.id]: val };
  }, {});
  store.data = {
    ...store.data,
    ...insertData
  };
  processIncludedResources(json);
  store.meta = json.meta;
  store.links = json.links;
};
export const processGetData = async (json, store) => {
  const elementData = json.data;
  store.data[elementData.id] = elementData;
  processIncludedResources(json);
};
