import type { UseQueryOptions, UseMutationOptions } from 'vue-query';
import type { ResourceObject, NewResourceObject } from './types';
interface QueriesOptions {
    index?: Omit<UseQueryOptions<any, unknown, unknown, any>, "queryKey" | "queryFn">;
    get?: Omit<UseQueryOptions<any, unknown, unknown, any>, "queryKey" | "queryFn">;
    create?: Omit<UseMutationOptions<any, unknown, any, unknown>, "mutationFn">;
    update?: Omit<UseMutationOptions<any, unknown, {
        id: string;
        body: any;
    }, unknown>, "mutationFn">;
    delete?: Omit<UseMutationOptions<any, unknown, string, unknown>, "mutationFn">;
}
export declare const storeVueQuery: (store: any, apiResourceType?: string, queryOptions?: QueriesOptions) => {
    index: (queryParams?: {
        [key: string]: any;
    }) => Promise<void>;
    indexQuery: Omit<import("vue-query").UseQueryReturnType<unknown, unknown, import("vue-query").QueryObserverResult<unknown, unknown>>, "refetch" | "remove"> & {
        refetch: <TPageData>(options?: import("vue-query").RefetchOptions & import("vue-query").RefetchQueryFilters<TPageData>) => Promise<import("vue-query").QueryObserverResult<unknown, unknown>>;
        remove: () => void;
    };
    get: (id: string, queryParams?: {
        [key: string]: any;
    }) => Promise<void>;
    getQuery: Omit<import("vue-query").UseQueryReturnType<unknown, unknown, import("vue-query").QueryObserverResult<unknown, unknown>>, "refetch" | "remove"> & {
        refetch: <TPageData>(options?: import("vue-query").RefetchOptions & import("vue-query").RefetchQueryFilters<TPageData>) => Promise<import("vue-query").QueryObserverResult<unknown, unknown>>;
        remove: () => void;
    };
    create: (body: NewResourceObject) => Promise<void>;
    createQuery: import("vue-query").UseMutationReturnType<any, unknown, any, unknown, {
        error: unknown;
        data: any;
        isError: boolean;
        isLoading: boolean;
        isSuccess: boolean;
        status: "error" | "idle" | "loading" | "success";
        failureCount: number;
        isPaused: boolean;
        variables: any;
        context: unknown;
        isIdle: boolean;
    }>;
    update: (id: string, body: ResourceObject) => Promise<void>;
    updateQuery: import("vue-query").UseMutationReturnType<any, unknown, {
        id: string;
        body: any;
    }, unknown, {
        error: unknown;
        data: any;
        isError: boolean;
        isLoading: boolean;
        isSuccess: boolean;
        status: "error" | "idle" | "loading" | "success";
        failureCount: number;
        isPaused: boolean;
        variables: {
            id: string;
            body: any;
        };
        context: unknown;
        isIdle: boolean;
    }>;
    delete: (id: string) => Promise<void>;
    deleteQuery: import("vue-query").UseMutationReturnType<any, unknown, string, unknown, {
        error: unknown;
        data: any;
        isError: boolean;
        isLoading: boolean;
        isSuccess: boolean;
        status: "error" | "idle" | "loading" | "success";
        failureCount: number;
        isPaused: boolean;
        variables: string;
        context: unknown;
        isIdle: boolean;
    }>;
};
export {};
